/* File: all-strings.cpp
 *
 * A program that lists off all strings of length at most some
 * constant.
 */
#include <iostream>
#include <string>
#include "simpio.h"
#include "queue.h"
using namespace std;

/* The maximum length of the strings to generate. */
const int kMaxLength = 5;

int main() {
	/* Create a queue and seed it with the empty string. */
	Queue<string> worklist;
	worklist.enqueue("");
	
	/* Keep processing the strings one at a time until we're done. */
	while (!worklist.isEmpty()) {
		string current = worklist.dequeue();
		cout << current << endl;
		
		/* If we haven't hit the maximum possible length, add all successors
		 * of this string.
		 */
		if (current.length() < kMaxLength) {
			for (char ch = 'a'; ch <= 'z'; ch++) {
				worklist.enqueue(current + ch);
			}
		}
	}
	
	return 0;
}





		
	
