/* File: recursive-search.cpp
 *
 * A program that lists off all strings of length at most some
 * constant, but which operates recursively.
 */

#include <iostream>
#include <string>
#include "simpio.h"
using namespace std;

/* Generates all strings of length at most maxLength,
 * prefixed with the string soFar.
 */
void generate(string soFar, int maxLength) {
	/* Print out the string so far. */
	cout << soFar << endl;
	
	/* Recursively print out all strings with this prefix. */
	if (soFar.length() < maxLength) {
		for (char ch = 'a'; ch <= 'z'; ch++) {
			generate(soFar + ch, maxLength);
		}
	}
}

int main() {
	generate("", 5);
	return 0;
}



		
	
